/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VMaelstromTaxonomyRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VMaelstromTaxonomy extends TableImpl<VMaelstromTaxonomyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_maelstrom_taxonomy</code>
     */
    public static final VMaelstromTaxonomy V_MAELSTROM_TAXONOMY = new VMaelstromTaxonomy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VMaelstromTaxonomyRecord> getRecordType() {
        return VMaelstromTaxonomyRecord.class;
    }

    /**
     * The column <code>common_dd.v_maelstrom_taxonomy.taxonomy</code>.
     */
    public final TableField<VMaelstromTaxonomyRecord, String> TAXONOMY = createField(DSL.name("taxonomy"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_maelstrom_taxonomy.vocabulary</code>.
     */
    public final TableField<VMaelstromTaxonomyRecord, String> VOCABULARY = createField(DSL.name("vocabulary"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_maelstrom_taxonomy.term</code>.
     */
    public final TableField<VMaelstromTaxonomyRecord, String> TERM = createField(DSL.name("term"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_maelstrom_taxonomy.string_agg</code>.
     */
    public final TableField<VMaelstromTaxonomyRecord, String> STRING_AGG = createField(DSL.name("string_agg"), SQLDataType.CLOB, this, "");

    private VMaelstromTaxonomy(Name alias, Table<VMaelstromTaxonomyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VMaelstromTaxonomy(Name alias, Table<VMaelstromTaxonomyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_maelstrom_taxonomy" as  SELECT split_part(a.key, '::'::text, 1) AS taxonomy,
          split_part(a.key, '::'::text, 2) AS vocabulary,
          a.value AS term,
          string_agg(e.unique_name, ', '::text) AS string_agg
         FROM (common_dd.t_core_annotation a
           LEFT JOIN common_dd.t_core_element_hierarchy e ON ((e.key_element = a.fk_element)))
        WHERE (a.source = 'maelstrom'::common_dd.enum_annotationsource)
        GROUP BY a.key, a.value;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_maelstrom_taxonomy</code> table
     * reference
     */
    public VMaelstromTaxonomy(String alias) {
        this(DSL.name(alias), V_MAELSTROM_TAXONOMY);
    }

    /**
     * Create an aliased <code>common_dd.v_maelstrom_taxonomy</code> table
     * reference
     */
    public VMaelstromTaxonomy(Name alias) {
        this(alias, V_MAELSTROM_TAXONOMY);
    }

    /**
     * Create a <code>common_dd.v_maelstrom_taxonomy</code> table reference
     */
    public VMaelstromTaxonomy() {
        this(DSL.name("v_maelstrom_taxonomy"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VMaelstromTaxonomy as(String alias) {
        return new VMaelstromTaxonomy(DSL.name(alias), this);
    }

    @Override
    public VMaelstromTaxonomy as(Name alias) {
        return new VMaelstromTaxonomy(alias, this);
    }

    @Override
    public VMaelstromTaxonomy as(Table<?> alias) {
        return new VMaelstromTaxonomy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VMaelstromTaxonomy rename(String name) {
        return new VMaelstromTaxonomy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VMaelstromTaxonomy rename(Name name) {
        return new VMaelstromTaxonomy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VMaelstromTaxonomy rename(Table<?> name) {
        return new VMaelstromTaxonomy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromTaxonomy where(Condition condition) {
        return new VMaelstromTaxonomy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromTaxonomy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromTaxonomy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromTaxonomy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromTaxonomy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromTaxonomy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromTaxonomy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromTaxonomy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromTaxonomy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromTaxonomy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
